%define distname	spring_%{version}

%define Werror_cflags	%nil

Summary:	Realtime strategy game (inspired by Total Annihilation)
Name:		spring
Version:	103.0
Release:	%mkrel 4
License:	GPLv2+
Group:		Games/Strategy
URL:		http://springrts.com
Source0:	http://downloads.sourceforge.net/springrts/%{name}_%{version}_src.tar.lzma

BuildRequires:	allegro4-devel
BuildRequires:	asciidoc
BuildRequires:	boost-devel
BuildRequires:	cmake
BuildRequires:	desktop-file-utils
BuildRequires:	docbook-style-xsl
BuildRequires:	icoutils
BuildRequires:	java-devel
BuildRequires:	jsoncpp-devel
BuildRequires:	maven-local
BuildRequires:	p7zip
BuildRequires:	pkgconfig(assimp)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(glew)
BuildRequires:	pkgconfig(IL)
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(libunwind)
BuildRequires:	pkgconfig(openal)
BuildRequires:	pkgconfig(python2)
BuildRequires:	pkgconfig(sdl2)
BuildRequires:	pkgconfig(vorbisfile)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	python-pygccxml
BuildRequires:	xsltproc
# Some mod is required, this is the one that was shipped with
# spring-data:
Recommends:	spring-mod-nanoblobs
# Some map is required, these are the default maps from the
# installer:
Recommends:	spring-maps-default
# Internet lobby and springsettings:
Recommends:	springlobby

ExclusiveArch:	%{ix86} x86_64

%description
Spring is a 3D realtime strategy game. It was inspired by Total
Annihilation and has the same features Total Annihilation had, and
more.

%prep
%setup -qn %{name}_%{version}

cat > README.install.urpmi <<EOF
If you want to install additional mods and maps that are not available as
Mageia packages, you can install them inside your homedir in subdirectories
.spring/maps and .spring/mods.
EOF

 sed -i "s/FE_DFL_ENV/FE_DFL_ENV_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp rts/lib/streflop/SMath.cpp
 sed -i "s/FE_INVALID/FE_INVALID_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DENORMAL/FE_DENORMAL_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DIVBYZERO/FE_DIVBYZERO_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_OVERFLOW/FE_OVERFLOW_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_UNDERFLOW/FE_UNDERFLOW_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_INEXACT/FE_INEXACT_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_ALL_EXCEPT/FE_ALL_EXCEPT_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DOWNWARD/FE_DOWNWARD_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_TONEAREST/FE_TONEAREST_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_TOWARDZERO/FE_TOWARDZERO_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_UPWARD/FE_UPWARD_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/feclearexcept/feclearexcept_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp

%build
export CFLAGS="%{optflags} -fpermissive"
export CXXFLAGS="%{optflags} -fpermissive"
export LDFLAGS="-ldl"

%cmake -DBINDIR=%{_gamesbindir} \
       -DLIBDIR=%{_lib}/%{name} \
       -DPRD_BINDIR=%{_gamesbindir} \
       -DPRD_JSONCPP_INTERNAL=OFF \
       -DJAVA_INCLUDE_PATH=%{java_home}/include \
       -DJAVA_INCLUDE_PATH2=%{java_home}/include/linux \
       -DJAVA_AWT_INCLUDE_PATH=%{java_home}/include

%make

%install
%make_install -C build

# Nanar:
# need by spring dedicated server
# it is not installed

mkdir -p %{buildroot}%{_libdir}/

rm -fr %{buildroot}%{_datadir}/doc

# KAI is deprecated: http://spring.clan-sy.com/phpbb/viewtopic.php?f=20&t=18196
rm -f %{buildroot}%{_libdir}/%{name}/AI/Bot-libs/libKAI-0.2.so


pushd rts
icotool -x %{name}.ico
for size in 16x16 64x64 128x128 256x256; do
  mkdir -p %{buildroot}%{_iconsdir}/hicolor/${size}/apps
  install -m 644 %{name}*${size}x32.png %{buildroot}%{_iconsdir}/hicolor/${size}/apps/%{name}.png
done
mkdir -p %{buildroot}%{_iconsdir}/hicolor/scalable/apps
install -m 644 %{name}.svg %{buildroot}%{_iconsdir}/hicolor/scalable/apps/%{name}.svg
popd

perl -pi -e 's|^Exec=.*|Exec=%{_gamesbindir}/%{name}|' %{buildroot}%{_datadir}/applications/%{name}.desktop
perl -pi -e 's|true|false|' %{buildroot}%{_datadir}/applications/%{name}.desktop
desktop-file-install \
  --vendor="" \
  --remove-category="Application" \
  --dir %{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/%{name}.desktop


install -d -m755 %{buildroot}%{_sysconfdir}/%{name}
echo '$HOME/.spring' > %{buildroot}%{_sysconfdir}/%{name}/datadir
echo '%{_gamesdatadir}/%{name}' >> %{buildroot}%{_sysconfdir}/%{name}/datadir

install -d -m755 %{buildroot}%{_gamesdatadir}/%{name}/{mods,maps}

rm -rf %{buildroot}%{_datadir}/pixmaps/*.png

%files
%doc README.install.urpmi
%{_sysconfdir}/%{name}
%{_gamesbindir}/*
%{_gamesdatadir}/%{name}/
%{_iconsdir}/hicolor/*/apps/%{name}.*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_libdir}/%{name}/
%{_mandir}/man*/spring*


%changelog
* Thu Jun 01 2017 neoclust <neoclust> 103.0-4.mga6
+ Revision: 1105746
- Do not build on arm

* Sun Mar 12 2017 akien <akien> 103.0-3.mga6
+ Revision: 1092250
- Rebuild against allegro4

* Mon Jan 02 2017 akien <akien> 103.0-2.mga6
+ Revision: 1079580
- Rebuild for libjsoncpp changed soname

* Wed Dec 14 2016 zezinho <zezinho> 103.0-1.mga6
+ Revision: 1075093
- new version

* Thu Apr 14 2016 daviddavid <daviddavid> 101.0-1.mga6
+ Revision: 1001366
- new version: 101.0
- add BR jsoncpp-devel

* Sun Dec 27 2015 daviddavid <daviddavid> 100.0-4.mga6
+ Revision: 916103
- rebuild for new boost 1.60.0

* Sat Sep 26 2015 fwang <fwang> 100.0-3.mga6
+ Revision: 883756
- rebuild for new boost

* Wed Aug 26 2015 cjw <cjw> 100.0-2.mga6
+ Revision: 869611
- rebuild with gcc 5

* Thu Aug 06 2015 shlomif <shlomif> 100.0-1.mga6
+ Revision: 861471
- New version 100.0 (patch thx to ysoft).

  + daviddavid <daviddavid>
    - rebuild for new boost-1.58.0

* Wed Jun 24 2015 akien <akien> 97.0-8.mga6
+ Revision: 842158
- Rebuild for GLEW 1.12

* Sat Nov 01 2014 akien <akien> 97.0-7.mga5
+ Revision: 795102
- Do not use system font, it does not exist

* Fri Oct 31 2014 spuhler <spuhler> 97.0-6.mga5
+ Revision: 794973
- Drop no longer needed BuildRequires on java-rpmbuild

* Wed Oct 15 2014 umeabot <umeabot> 97.0-5.mga5
+ Revision: 743125
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

  + spuhler <spuhler>
    - added back the FreeSansBold.otf
    - removed deprecated KAI

  + tv <tv>
    - s/uggests:/Recommends:/

* Tue Sep 09 2014 fwang <fwang> 97.0-3.mga5
+ Revision: 673999
- fix build against glew 1.11

  + luigiwalser <luigiwalser>
    - rebuild for glew

* Fri Aug 29 2014 spuhler <spuhler> 97.0-2.mga5
+ Revision: 669184
- added cmake patch to make it build with cmake-3
- reported bug upstream

* Fri Jun 27 2014 akien <akien> 97.0-1.mga5
+ Revision: 640383
- Add scalable (svg) icon

  + spuhler <spuhler>
    - added BuildRequires: sdl2-devel and BuildRequires: assimp
    - added spring-97.0-assimp-remove.patch
    - replaced spring-96.0-link.patch with spring-97.0-link.patch
    - upgrade to ver 97.0
    - reversed the last change.
      * problem is somewhere else

* Wed Jun 25 2014 spuhler <spuhler> 96.0-2.mga5
+ Revision: 639747
- commented out BuildRequires:  python-pygccxml
  * to make it build on the BS
- rebuild agains new boost
- added BuildRequires:  python-pygccxml and git
  * configure suggests it
- removed libspringserver.so
  *  not provided anymore
- reversed removed the archlinux patch
- added BuildRequires:  java-1.7.0-openjdk-devel
- removed the archlinux patch (they dropped it too)
- changed %%make to make (making fails randomly)
-added rediffed patches
- upgrade to version 96.0

  + barjac <barjac>
    - rebuild against boost-1.55

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Sun Jul 28 2013 fwang <fwang> 94.1-5.mga4
+ Revision: 459699
- rebuild for new glew

* Wed Jul 10 2013 fwang <fwang> 94.1-4.mga4
+ Revision: 452535
- rebuild for new boost

* Wed Jun 12 2013 fwang <fwang> 94.1-3.mga4
+ Revision: 442067
- mor static lib

* Wed Jun 12 2013 fwang <fwang> 94.1-2.mga4
+ Revision: 442048
- more static lib
- fix linkage
- add more br

* Wed Jun 12 2013 fwang <fwang> 94.1-1.mga4
+ Revision: 442036
- rediff patches
- new version 94.1

* Wed Apr 10 2013 barjac <barjac> 91.0-6.mga3
+ Revision: 409456
- rebuild for boost-1.53

* Mon Jan 14 2013 umeabot <umeabot> 91.0-5.mga3
+ Revision: 382527
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 20 2012 fwang <fwang> 91.0-4.mga3
+ Revision: 333105
- rebuild for new boost

* Sat Dec 01 2012 neoclust <neoclust> 91.0-3.mga3
+ Revision: 323585
- Rediff P3
- New version 91.0

* Thu Aug 30 2012 fwang <fwang> 89.0-3.mga3
+ Revision: 285671
- rebuild for new glew

* Sat Aug 04 2012 fwang <fwang> 89.0-2.mga3
+ Revision: 278358
- fix build with boost 1.50
- rebuild for new boost

* Mon Jul 16 2012 nanardon <nanardon> 89.0-1.mga3
+ Revision: 271538
- 0.89

* Wed Jun 27 2012 dams <dams> 88.0-2.mga3
+ Revision: 264472
- replace Mandriva with Mageia in README.install.urpmi
- update icon size to improve GNOME3 experience
- fix .desktop to have the entry menu to be displayed

* Wed Jun 27 2012 nanardon <nanardon> 88.0-1.mga3
+ Revision: 264364
- fix build with gcc-4.7
- 88.0

* Wed May 30 2012 kamil <kamil> 85.0-2.mga3
+ Revision: 249754
- rebuild against boost 1.49.0

* Wed Feb 08 2012 nanardon <nanardon> 85.0-1.mga2
+ Revision: 206460
- 0.85

* Mon Dec 05 2011 fwang <fwang> 84.0-1.mga2
+ Revision: 176797
- fix file list
- add archlinux patch to get it build
- new version 84.0
- rebuild for new boost

* Thu Nov 03 2011 mikala <mikala> 0.82.7.1-4.mga2
+ Revision: 162000
- Add patch2 from fedora to fix java build

  + fwang <fwang>
    - rebuild for new glew
    - rebuild for new boost

* Wed Jun 22 2011 fwang <fwang> 0.82.7.1-2.mga2
+ Revision: 111987
- rebuild for new boost

* Sat Mar 12 2011 nanardon <nanardon> 0.82.7.1-1.mga1
+ Revision: 69664
- 0.82.7.1

* Mon Mar 07 2011 nanardon <nanardon> 0.82.6.1-1.mga1
+ Revision: 65818
- mdv cleanup
- imported package spring


* Sun Nov 14 2010 Olivier Thauvin <nanardon@mandriva.org> 0.82.6.1-1mdv2011.0
+ Revision: 597531
- 0.82.6.1

  + Funda Wang <fwang@mandriva.org>
    - rebuild for new boost

* Thu Aug 19 2010 Olivier Thauvin <nanardon@mandriva.org> 0.82.3-1mdv2011.0
+ Revision: 571373
- 0.82.3

  + Funda Wang <fwang@mandriva.org>
    - add fedora patches
    - New version 0.81.2.1
    - rebuild for new boost

* Mon Feb 22 2010 Emmanuel Blindauer <blindauer@mandriva.org> 0.81.2-1mdv2010.1
+ Revision: 509782
- release 0.81.2

* Mon Feb 08 2010 Anssi Hannula <anssi@mandriva.org> 0.81.1.3-3mdv2010.1
+ Revision: 501882
- rebuild for new boost

* Wed Feb 03 2010 Funda Wang <fwang@mandriva.org> 0.81.1.3-2mdv2010.1
+ Revision: 500334
- rebuild for new boost

* Sun Jan 31 2010 Emmanuel Blindauer <blindauer@mandriva.org> 0.81.1.3-1mdv2010.1
+ Revision: 498881
- try disabling unitsync
- 0.81.1.3 release

* Mon Dec 28 2009 Emmanuel Blindauer <blindauer@mandriva.org> 0.80.5.2-1mdv2010.1
+ Revision: 482987
- Fix compilation
- 7zip required now
- 0.80.5.2 release

* Mon Aug 31 2009 Emmanuel Blindauer <blindauer@mandriva.org> 0.80.4-1mdv2010.0
+ Revision: 422779
- version 0.80.4

* Mon Aug 24 2009 Emmanuel Blindauer <blindauer@mandriva.org> 0.80.2-2mdv2010.0
+ Revision: 420256
- third try to submit it to the BS
- new version 0.80.2

* Fri Aug 21 2009 Funda Wang <fwang@mandriva.org> 0.79.1.2-3mdv2010.0
+ Revision: 418898
- seems build correctly

* Mon Jul 13 2009 Anssi Hannula <anssi@mandriva.org> 0.79.1.2-2mdv2010.0
+ Revision: 395426
- fix debugging symbols

* Mon Jul 13 2009 Olivier Thauvin <nanardon@mandriva.org> 0.79.1.2-1mdv2010.0
+ Revision: 395421
- 0.79.1.2

  + Anssi Hannula <anssi@mandriva.org>
    - rediff and re-enable unitsynclog.patch

* Tue May 26 2009 Adam Williamson <awilliamson@mandriva.org> 0.79.0.2-1mdv2010.0
+ Revision: 379968
- add literal.patch to fix a string literal error
- revise and rename the font patch luxi.patch -> font.patch (upstream switched fonts)
- new release 0.79.0.2

* Thu Mar 12 2009 Emmanuel Andry <eandry@mandriva.org> 0.78.2.1-2mdv2009.1
+ Revision: 354302
- rebuild for new boost

* Wed Jan 21 2009 Adam Williamson <awilliamson@mandriva.org> 0.78.2.1-1mdv2009.1
+ Revision: 332300
- drop literal.patch (fixed upstream)
- new release 0.78.2.1
- temporarily disable unitsynclog.patch (code has changed completely, may no
  longer be needed)
- add literal.patch (fix two string literal errors, reported upstream)
- rediff luxi.patch
- new release 0.78.1.1

* Sat Dec 20 2008 Funda Wang <fwang@mandriva.org> 0.77b5-2mdv2009.1
+ Revision: 316583
- rebuild for new boost

* Sun Dec 14 2008 Adam Williamson <awilliamson@mandriva.org> 0.77b5-1mdv2009.1
+ Revision: 314119
- rebuild for new boost
- update file lists
- do update_mime_database in %%post for older releases
- make sure to set all necessary paths for cmake
- drop messy scons stuff
- switch to cmake buildsystem: it's less painful than scons
- buildrequires libxcursor-devel
- rediff unitsynclog.patch
- drop javapath.patch (not needed with the cmake buildsystem, can all be done
  with cmake parameters)
- rediff luxi.patch
- tabs not spaces
- disable ld_noundefined (no shared lib, and the cmake system has underlinking
  issues)
- drop unnecessary defines

* Sat Jan 05 2008 Anssi Hannula <anssi@mandriva.org> 0.76b1-1mdv2008.1
+ Revision: 145679
- 0.76b1
- rediff luxi.patch
- fix java support (javapath.patch)
- create unitsync.log always in ~/.spring, not in pwd (unitsynclog.patch)
- drop spring-data and add suggests to a default mod, mappack and lobby
- build with strip=0
- use parallel build
- provide directories for maps and mods
- provide documentation and README.install.urpmi
- disable ccache as the configure script does not like it

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

  + Funda Wang <fwang@mandriva.org>
    - BR java things
    - New version 0.75b2

  + Adam Williamson <awilliamson@mandriva.org>
    - hopefully fix conflicts with spring-data package
    - fix issues in XDG menu entry
    - new license policy

* Mon Apr 30 2007 Olivier Blin <oblin@mandriva.com> 0.74-0.b3.1mdv2008.0
+ Revision: 19551
- beta 3


* Sun Feb 04 2007 Anssi Hannula <anssi@mandriva.org> 0.74-0.b2.2mdv2007.0
+ Revision: 116164
- add $HOME/.spring as r/w datadir
- own %%{_libdir}/%%{name}

* Tue Jan 23 2007 Olivier Blin <oblin@mandriva.com> 0.74-0.b2.1mdv2007.1
+ Revision: 112364
- fix libdir on x86_64
- use scons configure to set installprefix
- buildrequires zip (to build sdz files)
- buildrequire scons (obviously)
- initial Spring release
- renamed taspring as spring (new upstream name)
- Created package structure for taspring.

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - New version 0.74 Beta2

